package sample_x5_nj_servlet_ko;

import java.io.File;
import java.io.IOException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import devpia.dextuploadnj.support.common.FileDownload;

public class CommonDownload extends HttpServlet {
	
	private static final long serialVersionUID = 1L;
	
	private String fileRoot;
       
    public CommonDownload() {
        super();
    }
    
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		
		fileRoot = config.getServletContext().getRealPath("/files/attach/");
	}
	
	protected void doHead(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
		File target = null;
		
		String key = request.getParameter("key");
		
		if (key.equals("FID0001")) target = new File(fileRoot, "서강대교_509147.jpg");
		else if (key.equals("FID0002")) target = new File(fileRoot, "우도해변_239826.jpg");
		else if (key.equals("FID0003")) target = new File(fileRoot, "코스모스 (빈공간) 195779.jpg");
		
		if (target == null  || target.exists() == false || target.isFile() == false) {
			response.sendError(HttpServletResponse.SC_NOT_FOUND, "주어진 키에 해당하는 파일 정보가 없습니다.");
			return;
		}
		
		try {
			
			// FileDownload 객체를 생성합니다. 
			FileDownload dextnj = new FileDownload();
			
			// 인코딩을 UTF-8로 설정합니다.
			response.setCharacterEncoding("UTF-8");
			if (request.getHeader("User-Agent").indexOf("DEXTUploadX5") >= 0) {
				dextnj.setAllowingWeakRange(true);
			}
			// 파일을 첨부 파일 형식으로 다운로드합니다.
			dextnj.download(request, response, target);
			
		} catch (Exception e) {
			throw new ServletException(e);
		}
	}
}
