package sample_x5_nj_servlet_ko;

import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import devpia.dextuploadnj.Environment;
import devpia.dextuploadnj.FileItem;
import devpia.dextuploadnj.FormItem;
import devpia.dextuploadnj.support.common.FileUpload;

public class MultipleUpload extends HttpServlet {
	
	private static final long serialVersionUID = 1L;	
	
	private Environment env;
       
    public MultipleUpload() {
        super();
    }

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		
		String temporaryDirPath = null;
		String repositoryDirPath = null;
		String licenseFilePath = null;		
		
		try {
			File rootDir = new File(config.getServletContext().getRealPath("/"));
			temporaryDirPath = new File(rootDir, "files/temp/").getCanonicalPath();
			repositoryDirPath = new File(rootDir, "files/attach/").getCanonicalPath();
			licenseFilePath = new File(rootDir, "WEB-INF/dextuploadnj.config").getCanonicalPath();
		} catch (IOException e) {
			throw new ServletException(e.getMessage());
		}		
		
		env = new Environment();
		env.setCharEncoding("UTF-8");
		env.setTempRepository(temporaryDirPath);
		env.setDefaultRepository(repositoryDirPath);
		env.setAutoMakingDirectory(true);
		env.setLicenseFilePath(licenseFilePath);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

		FileUpload dextnj = null;
		
		try { 
			dextnj = new FileUpload(request, env);
			dextnj.prepare();

			List<FileItem> items = dextnj.getFileItems();
			List<FormItem> controls = dextnj.getFormItems("DEXTUploadX5_ControlId");
			List<FormItem> ids = dextnj.getFormItems("DEXTUploadX5_UniqueId");

			StringBuffer sb = new StringBuffer();	
			
			FileItem file = null;
			FormItem ctr = null;
			FormItem fid = null;
			for (int i = 0; i < items.size(); i++) {
				
				file = items.get(i);
				ctr = controls.get(i);
				fid = ids.get(i);
				
				if (file.isEmpty() == false) {
					file.save();

					sb.append(String.format("%1$s|%2$s|%3$s\n", ctr.getValue(), fid.getValue(), file.getFilename()));
				}
			}

			response.setCharacterEncoding("UTF-8");
			response.setContentType("text/plain");
			response.getWriter().write(sb.toString());
			
		} catch (Exception e) {
			throw new ServletException(e);
		} finally {
			if (dextnj != null) dextnj.close();
		}
	}
}
